/* xedencag - mongolian hack of saytime, aka saytime-mongolian.
**
** Copyright (C) of the modifications: (C) 1998 by Oliver Corff.
**
** All original conditions apply.
*/

/*
** saytime - audio time hack for the SPARCstation.
**
** Copyright (C) 1990 by Jef Poskanzer.
**
** Permission to use, copy, modify, and distribute this software and its
** documentation for any purpose and without fee is hereby granted, provided
** that the above copyright notice appear in all copies and that both that
** copyright notice and this permission notice appear in supporting
** documentation.  This software is provided "as is" without express or
** implied warranty.
*/

#include <stdio.h>
#include <time.h>
#include <sys/file.h>
#include <sys/fcntl.h>

/* Here are the defines for the thirty different phrases the program
** needs.  If you want to substitute your own voice for mine, I suggest
** you record the following lines:
**
**     The time is eight o'clock exactly.
**     The time is eight oh-eight and one second.
**     The time is eight oh-eight and eight seconds.
**     One.  Two.  Three.  Four.  Five.  Six.  Seven.  Eight.  Nine.  Ten.
**     Eleven.  Twelve.  Thirteen.  Fourteen.  Fifteen.  Sixteen.  Seventeen.
**     Eighteen.  Nineteen.  Twenty.  Thirty.  Forty.  Fifty.
**
** Then use Sun's sound demo to dissect the lines into separate files.
** It's not really that much work, it took me about an hour.
*/

#define PH_NOL		0
#define PH_NEG		1
#define PH_XOYOR	2
#define PH_GURWAN	3
#define PH_DORWON	4
#define PH_TAWAN	5
#define PH_ZURGAAN	6
#define PH_DOLOON	7
#define PH_NAIMAN	8
#define PH_YESON	9
#define PH_ARWAN	10
#define PH_XORIN	11
#define PH_GUQIN	12
#define PH_DOQIN	13
#define PH_TAWIN	14
#define PH_ODOO		15
#define PH_YAG		16
#define PH_CAG		17
#define PH_MINUT	18
#define PH_SEKUND	19

void saynumber(), saydigit(), sayphrase(), sayfile(), sayclose();

main( argc, argv )
int argc;
char *argv[];
    {
    long clock;
    struct tm *t;

    clock = time( (long *) 0 );
    t = localtime( &clock );

    sayphrase( PH_ODOO );

    saynumber( t->tm_hour, 0 );

    sayphrase ( PH_CAG );

    saynumber( t->tm_min, 1 );

    sayphrase( PH_MINUT );

    if ( t->tm_sec == 0 )
	sayphrase( PH_YAG );
    else
	{
	saynumber( t->tm_sec, 0 );
	sayphrase( PH_SEKUND );
	}

    sayclose( );
    exit( 0 );
    }

void
saynumber( n, leadingzero )
int n, leadingzero;
    {
    int ones, tens;

    ones = n % 10;
    tens = n / 10;

    switch ( tens )
	{
	case 0:
	saydigit( ones );
	break;

	case 1:
	sayphrase( PH_ARWAN );
	if ( ones != 0 )
	    saydigit( ones );
	break;

	case 2:
	sayphrase( PH_XORIN );
	if ( ones != 0 )
	    saydigit( ones );
	break;

	case 3:
	sayphrase( PH_GUQIN );
	if ( ones != 0 )
	    saydigit( ones );
	break;

	case 4:
	sayphrase( PH_DOQIN );
	if ( ones != 0 )
	    saydigit( ones );
	break;

	case 5:
	sayphrase( PH_TAWIN );
	if ( ones != 0 )
	    saydigit( ones );
	break;

	default:
	(void) fprintf( stderr, "Shouldn't happen.\n" );
	exit( 1 );
	}
    }

void
saydigit( n )
int n;
    {
    switch ( n )
	{
	case 0:
	sayphrase( PH_NOL );
	break;

	case 1:
	sayphrase( PH_NEG );
	break;

	case 2:
	sayphrase( PH_XOYOR );
	break;

	case 3:
	sayphrase( PH_GURWAN );
	break;

	case 4:
	sayphrase( PH_DORWON );
	break;

	case 5:
	sayphrase( PH_TAWAN );
	break;

	case 6:
	sayphrase( PH_ZURGAAN );
	break;

	case 7:
	sayphrase( PH_DOLOON );
	break;

	case 8:
	sayphrase( PH_NAIMAN );
	break;

	case 9:
	sayphrase( PH_YESON );
	break;

	default:
	(void) fprintf( stderr, "Minutes goofed. Shouldn't happen.\n" );
	exit( 1 );
	}
    }

void
sayphrase( phrase )
int phrase;
    {
    switch ( phrase )
	{
	case PH_NOL:
	sayfile( "0.au" );
	break;

	case PH_NEG:
	sayfile( "1.au" );
	break;

	case PH_XOYOR:
	sayfile( "2.au" );
	break;

	case PH_GURWAN:
	sayfile( "3.au" );
	break;

	case PH_DORWON:
	sayfile( "4.au" );
	break;

	case PH_TAWAN:
	sayfile( "5.au" );
	break;

	case PH_ZURGAAN:
	sayfile( "6.au" );
	break;

	case PH_DOLOON:
	sayfile( "7.au" );
	break;

	case PH_NAIMAN:
	sayfile( "8.au" );
	break;

	case PH_YESON:
	sayfile( "9.au" );
	break;

	case PH_ARWAN:
	sayfile( "10.au" );
	break;

	case PH_XORIN:
	sayfile( "20.au" );
	break;

	case PH_GUQIN:
	sayfile( "30.au" );
	break;

	case PH_DOQIN:
	sayfile( "40.au" );
	break;

	case PH_TAWIN:
	sayfile( "50.au" );
	break;

	case PH_ODOO:
	sayfile( "odoo.au" );
	break;

	case PH_CAG:
	sayfile( "cag.au" );
	break;

	case PH_YAG:
	sayfile( "yag.au" );
	break;

	case PH_SEKUND:
	sayfile( "sekund.au" );
	break;

	case PH_MINUT:
	sayfile( "minut.au" );
	break;

	default:
	(void) fprintf( stderr, "Shouldn't happen.\n" );
	exit( 1 );
	}
    }

int audiofd = -1;

void
sayfile( filename )
char *filename;
    {
    int filefd;
    int r, w;
    unsigned char buf[1024];
    char pathname[200];

    if ( audiofd == -1 )
	{
	audiofd = open( "/dev/audio", O_WRONLY | O_NDELAY );
	if ( audiofd < 0 )
	    {
	    perror( "opening /dev/audio" );
	    exit( 1 );
	    }
	}

    (void) sprintf( pathname, "%s/%s", SOUND_DIR, filename );
    filefd = open( pathname, O_RDONLY );
    if ( filefd < 0 )
	{
	perror( "opening audio file" );
	exit( 1 );
	}

    for ( ; ; )
	{
	r = read( filefd, buf, sizeof(buf) );
	if ( r < 0 )
	    {
	    perror( "reading from audio file" );
	    exit( 1 );
	    }
	if ( r == 0 )
	    break;

	for ( ; ; )
	    {
	    w = write( audiofd, buf, r );
	    if ( w < 0 )
		{
		perror( "writing to audio device" );
		exit( 1 );
		}
	    if ( w != 0 )
		break;
	    usleep( 1000 );
	    }
	if ( w != r )
	    {
	    (void) fprintf( stderr, "read returned %d, write returned %d\n", r, w );
	    exit( 1 );
	    }
	}
    close( filefd );
    }

void
sayclose( )
    {
    if ( audiofd != -1 )
	close( audiofd );
    audiofd = -1;
    }
